#Lang "fblite"
#Include "modshared.bi"

Print "Fake86 v0.2.7.11 (c)2010-2011 Mike Chambers"
Print "[A 8086 PC emulator written in FreeBASIC]"
Print

If Command$ <> "" Then
	InsertDisk 0, Command$
	Print "Disk image " + Command$ + " on floppy 0:"
	Print "  Cylinders: " + Str$(Disk(0).Cylinders)
	Print "    Sectors: " + Str$(Disk(0).Sectors)
	Print "      Heads: " + Str$(Disk(0).Heads)
	Print
Else
	Print "Loading emulator with no disk image."
	Print "You can specify a floppy image file on the command line."
EndIf

Open "ints.txt" For Output As #4
ScreenRes 640, 400, 24
outputlog = 0
InitCGA: running = 1
reset86
execloops = 10000 'the lower the number, the more frequently the screen is updated (it's smoother)
                 'but it will make the emulation slower. try ranges within 1000 to 50000 or so.
clocksafe = 0 'prevents firing of timer interrupt before BIOS set the vector. it's set to 1 once int 19h is hit.
InitOplist
OpenLogfile
Open "portlog.txt" For Output As #6
Do
	exec86
	VidRefresh
	GrabKey
Loop until keytmp$ = chr$(27) Or running = 0
Open "memdump.bin" For Binary As #3
For i = 0 To 655359
	Put #3, , RAM(i)
Next i
Close #3
Screen 0
Print "Exited on instruction " + Hex$(savecs) + ":" + Hex$(saveip) + " - " + Oplist(opcode)
Print "  AX = " + Right$("000" + Hex$(getreg16(ax)), 4) + "      BX = " + Right$("000" + Hex$(getreg16(bx)), 4) + "      CX = " + Right$("000" + Hex$(getreg16(cx)), 4) + "      DX = " + Right$("000" + Hex$(getreg16(dx)), 4)
Print "  CS = " + Right$("000" + Hex$(cs), 4) + "      IP = " + Right$("000" + Hex$(ip), 4) + "      SI = " + Right$("000" + Hex$(si), 4) + "      DI = " + Right$("000" + Hex$(di), 4)
Print "  DS = " + Right$("000" + Hex$(ds), 4) + "      ES = " + Right$("000" + Hex$(es), 4) + "      SS = " + Right$("000" + Hex$(ss), 4) + "      SP = " + Right$("000" + Hex$(sp), 4)
Print "  Flags: CF=" + Hex$(cf) + "    ZF=" + Hex$(zf) + "    SF=" + Hex$(sf) + "    OF=" + Hex$(of) + "    IF=" + Hex$(ifl) + "    AF=" + Hex$(af) + "    DF=" + Hex$(df) + "    PF=" + Hex$(pf)
End

#Include "modcpu.bas"
#Include "moddebug.bas"
#Include "moddisk.bas"
#Include "modflags.bas"
#Include "modgrp.bas"
#Include "modinterrupt.bas"
#Include "modopcodes.bas"
#Include "modoplist.bas"
#Include "modvideo.bas"
