Sub InsertDisk(ByVal DriveNum as LongInt, DiskFileName As String)
If Disk(DriveNum).Inserted = 1 Then Close DriveNum + 5
Disk(DriveNum).Inserted = 1
Disk(DriveNum).DiskFile = DiskFileName
Open Disk(DriveNum).DiskFile For Binary As #(DriveNum + 5)
If (DriveNum And &H80) = &H80 Then
    Disk(DriveNum).Sectors = 63: Disk(DriveNum).Heads = 16
    Disk(DriveNum).Cylinders = LOF(DriveNum + 5) \ (Disk(DriveNum).Sectors * Disk(DriveNum).Heads * 512)
    MsgBox "Using HD as" + Str$(Disk(DriveNum).Cylinders) + " cylinder disk."
Else
    Disk(DriveNum).Cylinders = 80: Disk(DriveNum).Sectors = 18: Disk(DriveNum).Heads = 2
    If LOF(DriveNum + 5) <= 1228800 Then Disk(DriveNum).Sectors = 15
    If LOF(DriveNum + 5) <= 737280 Then Disk(DriveNum).Sectors = 9
    If LOF(DriveNum + 5) <= 368640 Then Disk(DriveNum).Cylinders = 40: Disk(DriveNum).Sectors = 9
    If LOF(DriveNum + 5) <= 327680 Then Disk(DriveNum).Sectors = 8
End If
End Sub

Sub EjectDisk(ByVal DriveNum as LongInt)
Disk(DriveNum).Inserted = 0
Close DriveNum + 5
End Sub

Sub ReadDisk(ByVal DriveNum as uLong, ByVal DstSeg as ulong, ByVal DstOff as ulong, ByVal Cyl as ulong, ByVal Sect as ulong, ByVal Head as LongInt, ByVal SectCount as ulong)
Dim lba, MemDest as ULong
Dim cursect, curpos, goodsects as Ulong
lba = (Cyl * Disk(DriveNum).Heads * Disk(DriveNum).Sectors) + (Head * Disk(DriveNum).Sectors) + Sect - 1
MemDest = DstSeg * 16 + DstOff
Print #2, "Sector" + Str$(lba) + " read:" + Str$(al) + " sectors into " + Hex$(es) + ":" + Hex$(getreg16(bx))
For cursect = 0 To SectCount-1
	Seek #(drivenum + 5), lba * 512+1
    Get #(DriveNum + 5), , SectorBuffer(DriveNum)
    For curpos = 1 To 512
        RAM(MemDest) = Asc(Mid$(SectorBuffer(DriveNum), curpos, 1))
        MemDest = MemDest + 1
    Next curpos
    'If Err <> 0 Then Exit For
    goodsects = goodsects + 1
Next cursect
If Err <> 0 Then
    cf = 1: ah = 4
    al = goodsects
Else
    cf = 0: ah = 0
End If
End Sub

Sub WriteDisk(ByVal DriveNum as LongInt, ByVal SrcSeg as LongInt, ByVal SrcOff as LongInt, ByVal Cyl as LongInt, ByVal Sect as LongInt, ByVal Head as LongInt, ByVal SectCount as LongInt)
Dim lba, MemSrc as UInteger
Dim cursect, curpos, goodsects as UInteger
lba = (Cyl * Disk(DriveNum).Heads * Disk(DriveNum).Sectors) + (Head * Disk(DriveNum).Sectors) + Sect - 1
MemSrc = SrcSeg * 16 + SrcOff
If TraceLog = 1 Then Print #2, "Sector" + Str$(lba \ 512) + " read:" + Str$(al) + " sectors into " + Hex$(es) + ":" + Hex$(getreg16(bx))
For cursect = 0 To (SectCount*512)-1
    Put #(DriveNum + 5), lba*512+cursect, RAM(MemSrc)
    MemSrc = MemSrc + 1
Next cursect
    cf = 0: ah = 0
End Sub

Sub DiskHandler()
Select Case ah
    Case 0 'reset disk system
        ah = 0: cf = 0 'useless function in an emulator. say successful and return.
    
    Case 2 'read sector(s) into memory
        ReadDisk dl, es, getreg16(bx), ch, cl And 63, dh, al

	Case 3 'write disk sector(s)
        WriteDisk dl, es, getreg16(bx), ch, cl And 63, dh, al

    Case 8 'get drive parameters
        If Disk(dl).Inserted = 1 Then
            cf = 0: ah = 0
            ch = Disk(dl).Cylinders
            cl = Disk(dl).Sectors And 63
            dh = Disk(dl).Heads
        Else
            cf = 1: ah = 4
        End If
    
	Case &h15
		If dl<2 Then
			cf = 0
			ah = 1
			putreg16 cx, (Disk(dl).sectors * Disk(dl).Heads * Disk(dl).Cylinders) \ 256
			putreg16 dx, (Disk(dl).sectors * Disk(dl).Heads * Disk(dl).Cylinders) And 255
		Else
			cf = 0
			ah = 0
		End If
        
    Case &HE 'read sector buffer (XT only)
        If Disk(dl).Inserted = 1 Then
            cf = 0: ah = 0
            Dim curpos, MemDest as LongInt
            MemDest = es * 16 + getreg16(bx)
            For curpos = 1 To 512
                RAM(MemDest + curpos - 1) = Asc(Mid$(SectorBuffer(DriveNum), curpos, 1))
            Next curpos
        Else
            cf = 1: ah = 4
        End If
    
    Case &H41 'INT 13h extensions installation check
        cf = 1: ah = 1 'say it's not supported
        
    Case Else
        Screen 0
        Print "Unhandled interrupt 13h (disk services) function!" + Chr$(13)+Chr$(10) + "AX: " + Hex$(getreg16(ax)) + Chr$(13)+Chr$(10) + "DL: " + Hex$(dl)
        end
End Select
End Sub
