Sub intcall86(ByVal intnum As Integer)
If intnum <> &h10 And intnum <> &h16 And outputlog = 1 Then
	Print #4, "Interrupt call to " + Hex$(intnum) + " from "+Hex$(savecs)+":"+Hex$(saveip)+" - " + Oplist(opcode) +CrLf + "AX: " + Hex$(getreg16(ax)) + " - Reg is " + Str$(reg)
EndIf
If TraceLog = 1 Or outputlog = 1 Then Print #2, "  Interrupt call to " + Hex$(intnum) + "h"
Select Case intnum
    Case &H10 'video
        VidInterrupt
        Exit Sub
    
	Case &H13 'disk services
        DiskHandler
        Exit Sub
    
    Case &H16 'keyboard services
        KeyHandler
        Exit Sub
    
    Case &H19 'bootstrap
        BootHandler
        If Chr$(al) = "5" Then
        		If RAM(&hF6000&) <> 0 Then
        			ah = &H20: al = &H20: intnum = &H18
        		Else
        			EmuPrint "No ROM BASIC was loaded." + CrLf + CrLf
        		EndIf
        Else
        		Exit Sub
        EndIf
    
'uncomment the &h1A stuff to enable real system time
'	Case &h1A 'get system time
'    	temp1 = Timer
'    	putreg16 cx, temp1 \ 65536
'    	putreg16 dx, temp1 Mod 65536
'    	al = 0
'    	Exit sub
End Select
if (read86(intnum * 4 + 2) + read86(intnum * 4 + 3) * 256)=0 Then
	Print #4, "Call to interrupt "+Hex$(intnum)+"h, but no valid vector in place!"
	intnum = 8
End If

push makeflagsword
push cs: push ip
ip = read86(intnum * 4) + read86(intnum * 4 + 1) * 256
cs = read86(intnum * 4 + 2) + read86(intnum * 4 + 3) * 256
ifl = 0: tf = 0
End Sub

Sub BootHandler()
clocksafe = 1
portlog = 1
dodisasm = 0
outputlog = 0
Do
    EmuPrint "Fake86 bootstrap menu" + CrLf
    EmuPrint "=====================" + CrLf + CrLf
    EmuPrint "1. Floppy disk 0 (00h)" + CrLf
    EmuPrint "2. Floppy disk 1 (01h)" + CrLf
    EmuPrint "3. Hard disk 0 (80h)" + CrLf
    EmuPrint "4. Hard disk 1 (81h)" + CrLf
    EmuPrint "5. ROM BASIC" + CrLf + CrLf
    EmuPrint "Select an option above:"
    ah = 0: intcall86 &H16 'get keystroke
    EmuPrint Chr$(al) + CrLf + CrLf 'echo back selection to user
    al = al And 255 'just to be safe since we're going to pass it to Chr$()
    If running = 0 Then End
    
    Select Case Chr$(al) 'lets see what they pressed
        Case "1": If BootDrive(0) Then Exit Do
        Case "2": If BootDrive(1) Then Exit Do
        Case "3": If BootDrive(&H80) Then Exit Do
        Case "4": If BootDrive(&H81) Then Exit Do
    	Case "5": Exit Do 'ROM BASIC
      	Case Else
            EmuPrint "Invalid option!" + CrLf + CrLf
    End Select
Loop
End Sub

Sub EmuPrint(Message As String)
Dim oldah, oldal as LongInt
oldah = ah: oldal = al
ah = &HE
For tempprint = 1 To Len(Message)
    al = Asc(Mid$(Message, tempprint, 1))
    intcall86 &H10
Next tempprint
ah = oldah: al = oldal
End Sub

Function BootDrive(ByVal DriveNum as LongInt) as LongInt
If Disk(DriveNum).Inserted = 0 Then
    EmuPrint "Drive not ready. Mount an image file and try again." + CrLf + CrLf
    Exit Function
End If

dl = DriveNum

ReadDisk DriveNum, &h7C0, 0, 0, 1, 0, 1
'If read86(&H7DFE) = &H55 And read86(&H7DFF) = &HAA Then
    cs = 0: ip = &H7C00
    BootDrive = 1
'    Exit Function
'Else
'    EmuPrint "The mounted media does not have a valid boot sector!" + CrLf + CrLf
'End If
End Function

Sub KeyHandler()
        Select Case ah
            Case 0 'get keystroke
                If KeyBufferPos = 0 Then VidRefresh
                Do Until KeyBufferPos > 0
                    'DoEvents
                    GrabKey
                    checktick
                    If Shutdown = 1 Or Running = 0 Then Exit Sub
                Loop
                ah = KeyBuffer(KeyBufferPos - 1)\256: al = KeyBuffer(KeyBufferPos - 1) And 255
                'If ah = 255 Then ah = 59: al = 59
                KeyBufferPos = KeyBufferPos - 1
            
            Case 1 'check for keystroke
                If KeyBufferPos > 0 Then
                    zf = 0
                    ah = KeyBuffer(KeyBufferPos - 1)\256: al = KeyBuffer(KeyBufferPos - 1) And 255
                Else
                    zf = 1
                End If
            
        	Case 2 'get shift flags
            	al = 0
            Case Else
                Print "Unhandled function on interrupt 16h:" + CrLf + "AX: " + Hex$(ah)
        End Select
End Sub
